﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2015 Joseph Helm and Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion


using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Encodings.PermutationEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Problems.BinPacking;


namespace HeuristicLab.Encodings.PackingEncoding.PackingSequence {
  [Item("PackingSequence PMX", "An operator which crosses two PackingSequence representations using the OX-strategy.")]
  [StorableClass]
  public class PackingSequencePartiallyMatchedCrossover : PackingSequenceCrossover {

    [StorableConstructor]
    protected PackingSequencePartiallyMatchedCrossover(bool deserializing) : base(deserializing) { }
    protected PackingSequencePartiallyMatchedCrossover(PackingSequencePartiallyMatchedCrossover original, Cloner cloner) : base(original, cloner) { }
    public PackingSequencePartiallyMatchedCrossover()
      : base() {
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new PackingSequencePartiallyMatchedCrossover(this, cloner);
    }

    public override Permutation Cross(IRandom random, Permutation parent1, Permutation parent2) {
      return PartiallyMatchedCrossover.Apply(random, parent1, parent2);
    }
  }
}
